<?php

/**
 * @file
 * Hooks implemented by flickrcollection module.
 */


/**
 * Implements hook_menu().
 */
function flickrcollection_menu() {
  $items = array();

  $items['admin/config/media/flickrcollection'] = array(
    'title' => 'FlickrCollection',
    'description' => 'Configure Collection ID for FlickrCollection',
    'page callback' => 'drupal_get_form',
    'page arguments' => array('flickrcollection_collection_form'),
    'access arguments' => array('administer flickr settings'),
    'file' => 'flickrcollection.admin.inc',
    'type' => MENU_NORMAL_ITEM,
  );

  return $items;
}


/**
 * Implements hook_form_FORM_ID_alter() for flickrgallery_settings_form().
 *
 * When a collection ID has been configured disable the sets field on the
 * flickrgallery settings.
 */
function flickrcollection_form_flickrgallery_settings_form_alter(&$form, &$form_state, $form_id) {
  if (variable_get('flickrcollection_collection_id')) {
    $form['flickrgallery_displaysets_bool']['#disabled'] = TRUE;
    $form['flickrgallery_displaysets_values']['#disabled'] = TRUE;
    $form['flickrgallery_displaysets_values']['#description'] = t('Disabled because a !collection-id specifies which sets to display.', array('!collection-id' => l(t('Collection ID'), 'admin/config/media/flickrcollection')));
  }
}


/**
 * Implements hook_cron().
 *
 * On cron runs update the list of sets in the collection.
 */
function flickrcollection_cron() {
  flickrcollection_get_sets_from_collection();
}


/**
 * Implements hook_cronapi().
 *
 * Provide more info on cron handling if ultimate_cron.module is used.
 */
function flickrcollection_cronapi($op, $job = NULL) {
  switch ($op) {
    case 'list':
      return array('flickrcollection_cron' => t('Update the list of sets in the Flickr Collection'));

    case 'rule':
      return '* */6 * * *';

    case 'configure':
      return 'admin/config/media/flickrcollection';
  }
}
